Internet Group Management Protocol Version 3 (IGMPv3) and Multicast Listener Discovery Version 2 (MLDv2) Message Extension
RFC 9279
Mahesh Sivakumar
Juniper Networks
64 Butler St
Milpitas
CA
95035
United States of America
sivakumar.mahesh@gmail.com
Stig Venaas
Cisco Systems, Inc.
Tasman Drive
San Jose
CA
95134
United States of America
stig@cisco.com
Zheng(Sandy) Zhang
ZTE Corporation
No. 50 Software Ave, Yuhuatai District
Nanjing
210000
China
zhang.zheng@zte.com.cn
Hitoshi Asaeda
National Institute of Information and Communications Technology
4-2-1 Nukui-Kitamachi, Koganei
Tokyo
184-8795
Japan
asaeda@nict.go.jp
August 2022
Routing
pim
Multicast
This document specifies a generic mechanism to extend IGMPv3 and Multicast Listener Discovery Version 2 (MLDv2) by using a list of TLVs (Type, Length, and Value).
Introduction
This document defines a generic method to extend IGMPv3 [RFC3376] and MLDv2 [RFC3810] messages to accommodate information other than what is contained in the current message formats. This is done by allowing a list of TLVs to be used in the Additional Data section of IGMPv3 and MLDv2 messages. This document defines a registry for such TLVs. Other documents will define their specific types, and their values and semantics. The extension would only be used when at least one TLV is to be added to the message. This extension also applies to the lightweight versions of IGMPv3 and MLDv2 as defined in [RFC5790].
When this extension mechanism is used, it replaces the Additional Data section defined in IGMPv3/MLDv2 with TLVs.
Additional Data is defined for Query messages in IGMPv3 (Section 4.1.10 of [RFC3376]) and MLDv2 (Section 5.1.12 of [RFC3810]), and for Report messages in IGMPv3 (Section 4.2.11 of [RFC3376]) and MLDv2 (Section 5.2.11 of [RFC3810]).
Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Extension Format
For each of the IGMPv3 and MLDv2 headers, a previously reserved bit is used to indicate the presence of this extension. When this extension is used, the Additional Data of IGMPv3 and MLDv2 messages is formatted as follows. Note that this format contains a variable number of TLVs. It MUST contain at least one TLV.
Extension Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|        Extension Type 1       |       Extension Length 1      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Extension Value 1                       |
.                               .                               .
.                               .                               .
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|        Extension Type 2       |       Extension Length 2      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Extension Value 2                       |
.                               .                               .
.                               .                               .
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|        Extension Type n       |       Extension Length n      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Extension Value n                       |
.                               .                               .
.                               .                               .
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Extension Type:
2 octets. This identifies a particular Extension Type as defined in the "IGMP/MLD Extension Types" registry. If this is not the first TLV, it will follow immediately after the end of the previous one. There is no alignment or padding.
Extension Length:
2 octets. This specifies the length in octets of the following Extension Value field. The length may be zero if no value is needed.
Extension Value:
This field contains the value. The specification defining the Extension Type describes the length and contents of this field.
IGMPv3 and MLDv2 messages are defined so they can fit within the network MTU in order to avoid fragmentation. An IGMPv3/MLDv2 Report message contains a number of records. The records are called Group Records for IGMPv3 and Address Records for MLDv2. When this extension mechanism is used, the number of records in each Report message SHOULD be kept small enough so that the entire message, including any extension TLVs, can fit within the network MTU.
Multicast Listener Query Extension
The MLDv2 Query message format [RFC3810] with extension is shown below. The E-bit MUST be set to 1 to indicate that the extension is present. Otherwise, it MUST be 0.
MLD Query Extension

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |  Type = 130   |      Code     |           Checksum            |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |    Maximum Response Code      |           Reserved            |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    *                                                               *
    |                                                               |
    *                       Multicast Address                       *
    |                                                               |
    *                                                               *
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |E| Resv|S| QRV |     QQIC      |     Number of Sources (N)     |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    *                                                               *
    |                                                               |
    *                       Source Address [1]                      *
    |                                                               |
    *                                                               *
    |                                                               |
    +-                                                             -+
    |                                                               |
    *                                                               *
    |                                                               |
    *                       Source Address [2]                      *
    |                                                               |
    *                                                               *
    |                                                               |
    +-                              .                              -+
    .                               .                               .
    .                               .                               .
    +-                                                             -+
    |                                                               |
    *                                                               *
    |                                                               |
    *                       Source Address [N]                      *
    |                                                               |
    *                                                               *
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                            Extension                          |
    ~                                                               ~
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Version 2 Multicast Listener Report Extension
The MLDv2 Report message format [RFC3810] with extension is shown below. The E-bit MUST be set to 1 to indicate that the extension is present. Otherwise, it MUST be 0.
MLD Report Extension

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |  Type = 143   |    Reserved   |           Checksum            |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |E|         Reserved            |Nr of Mcast Address Records (M)|
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                  Multicast Address Record [1]                 .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                  Multicast Address Record [2]                 .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                               .                               |
    .                               .                               .
    |                               .                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                  Multicast Address Record [M]                 .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                            Extension                          |
    ~                                                               ~
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
IGMP Membership Query Extension
The IGMPv3 Query message format [RFC3376] with the extension is shown below. The E-bit MUST be set to 1 to indicate that the extension is present. Otherwise, it MUST be 0.
IGMP Query Extension

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |  Type = 0x11  | Max Resp Code |           Checksum            |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                         Group Address                         |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |E| Resv|S| QRV |     QQIC      |     Number of Sources (N)     |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                       Source Address [1]                      |
    +-                                                             -+
    |                       Source Address [2]                      |
    +-                              .                              -+
    .                               .                               .
    .                               .                               .
    +-                                                             -+
    |                       Source Address [N]                      |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                            Extension                          |
    ~                                                               ~
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
IGMP Version 3 Membership Report Extension
The IGMPv3 Report message format [RFC3376] with the extension is shown below. The E-bit MUST be set to 1 to indicate that the extension is present. Otherwise, it MUST be 0.
IGMP Report Extension

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |  Type = 0x22  |    Reserved   |           Checksum            |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |E|         Reserved            |  Number of Group Records (M)  |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                        Group Record [1]                       .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                        Group Record [2]                       .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                               .                               |
    .                               .                               .
    |                               .                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    .                                                               .
    .                        Group Record [M]                       .
    .                                                               .
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                            Extension                          |
    ~                                                               ~
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
No-op TLV
The No-op TLV is a No-Operation TLV that MUST be ignored during processing. This TLV may be used to verify that the extension mechanism has been implemented correctly. Note that there is no alignment requirement, so there is no need to use this Extension Type to provide alignment.
No-op TLV Format

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |        No-op Type = 0         |          No-op Length         |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                             Value                             |
    .                               .                               .
    .                               .                               .
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
No-op Type:
2 octets. The type of the No-op TLV extension is 0.
Extension Length:
2 octets. This specifies the length in octets of the following Value field. The length may be zero if no value is needed.
Value:
This field contains the value. As this Extension Type is always ignored, the value can be arbitrary data. The number of octets used MUST match the specified length.
Processing the Extension
The procedure specified in this document only applies when the E-bit is set.
If the validation of the TLVs fails, the entire Additional Data field MUST be ignored as specified in IGMPv3 [RFC3376] and MLDv2 [RFC3810]. The following checks must pass for the validation of the TLVs not to fail:
- At least one TLV MUST be present.
- There MUST NOT be any data in the IP payload after the last TLV. To check this, the parser needs to walk through each of the TLVs until there are less than four octets left in the IP payload. If there are any octets left, validation fails.
- The total length of the Extension MUST NOT exceed the remainder of the IP payload length. For this validation, only the content of the Extension Length fields is examined.
Future documents defining a new Extension Type MUST specify any additional processing and validation. These rules, if any, will be examined only after the general validation succeeds.
TLVs with unsupported Extension Types MUST be ignored.
Applicability and Backwards Compatibility
IGMP and MLD implementations, particularly implementations on hosts, rarely change. The adoption process of this extension mechanism is expected to be slow. As new extension TLVs are defined, it may take a long time for them to be supported. Due to this, defining new extension TLVs should not be taken lightly, and it is crucial to consider backwards compatibility.
Implementations that do not support this extension mechanism will ignore it, as specified in [RFC3376] and [RFC3810]. As mentioned in the previous section, unsupported extension TLVs are ignored.
It is possible that a new extension TLV will only apply to queries or only to reports, or that there may be other specific conditions for when it is to be used. A document defining a new Extension Type MUST specify the conditions under which the new Extension Type should be used, including which message types. It MUST also be specified what the behavior should be if a message is not used in the defined manner, e.g., if it is present in a Query message, when it was only expected to be used in reports.
When defining new Extension Types, the effect of partial support for the new TLV, by either the hosts or routers, on the same link should be carefully considered. Further, whether there are any dependencies or restrictions on combinations between the new Extension Types and any preexisting Extension Types must be considered.
This document defines an extension mechanism only for IGMPv3 and MLDv2. Hence, this mechanism does not apply if hosts or routers send older version messages.
Security Considerations
The Security Considerations of [RFC3376] and [RFC3810] also apply here.
This document extends the IGMP and MLD message formats, allowing for a variable number of TLVs. Implementations must take care not to exceed the packet boundary when parsing the TLVs, because an attacker could intentionally specify a TLV with a length exceeding the boundary.
An implementation could add a large number of minimal TLVs in a message to increase the cost of processing the message. This would magnify a denial-of-service attack.
IANA Considerations
IANA has created a new registry called "IGMP/MLD Extension Types" in the "Internet Group Management Protocol (IGMP) Type Numbers" section and lists this document as the reference. The registration procedure is "IETF Review" [RFC8126]. The registry is common for IGMP and MLD.
Two Extension Types (65534 and 65535) are provided for "Experimental Use" [RFC8126]. Any experiments should be confined to closed environments where it is unlikely that they may conflict with other experiments; see [RFC3692].
IANA has initially populated the registry as shown in Table 1
IGMP/MLD Extension Types
Extension Type | Length | Name | Reference
0 | variable | No-op | RFC 9279
1-65533 | | Unassigned |
65534-65535 | variable | Reserved for Experimental Use |
References
Normative References
Informative References
[RFC3376]
[RFC3810]
[RFC5790]
[RFC2119]
[RFC8174]
[RFC8126]
[RFC3692]
Acknowledgements
The authors thank Ron Bonica, Ian Duncan, Wesley Eddy, Leonard Giuliano, Jake Holland, Tommy Pauly, Pete Resnick, Alvaro Retana, and Zhaohui Zhang for reviewing the document and providing valuable feedback.